import Bean.HelloBean;
import Processor.HttpProcessor;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.impl.DefaultCamelContext;
import org.apache.camel.model.ModelCamelContext;
import org.apache.log4j.PropertyConfigurator;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * test
 */
public class BeanTest {

    //@Autowired
    //private HelloBean hello;
    public static void main(String[] args) throws Exception {
        PropertyConfigurator.configure("./conf/log4j.properties");

        ModelCamelContext camelContext = new DefaultCamelContext();
        camelContext.addRoutes(new RouteBuilder() {
            @Override
            public void configure() {
                from("jetty:http://127.0.0.1:8282/mStartFlow")
                        .process(new Processor() {
                            public void process(Exchange exchange) throws Exception {
                                // extract the name parameter from the Camel message which we want to use
                                // when invoking the bean
                                String name = exchange.getIn().getBody(String.class);

                                HelloBean hello = new HelloBean();
                                // invoke the bean which should have been injected by Spring
                                String answer = hello.hello(name);

                                // store the reply from the bean on the OUT message
                                exchange.getOut().setBody(answer);
                            }
                        });
            }});
        // 启动route
        camelContext.start();
        // 将我们编排的一个完整消息路由过程，加入到上下文中

    }
}
