import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.impl.DefaultCamelContext;
import org.apache.camel.model.ModelCamelContext;
import org.apache.log4j.PropertyConfigurator;

/**
 * Created by ztest on 2020/6/15
 */
public class Choice {
    public static void main(String[] args) throws Exception {
        PropertyConfigurator.configure("./conf/log4j.properties");

        ModelCamelContext camelContext = new DefaultCamelContext();
        camelContext.addRoutes(new RouteBuilder() {
            @Override
            public void configure() {
                restConfiguration().host("127.0.0.1")//127.0.0.1:8080/foo
                        .port("8287")//
                        .contextPath("xx")//
                        .setComponent("jetty");
                from("rest:get:controlBus/{action}/{routeId}")
                        .log("begin [ ${header.action} ] the route with id [ ${header.routeId}") //
                        // 其它诸如 suspend,resume,status,stats 可依据下面格式进行选择性添加
                        .choice() //
                        .when(simple("${header.action} == '1'"))
                            .to("log:show1?showExchangeId=true")
                        .when(simple("${header.action} == '2'"))
                            .to("log:show2?showExchangeId=true")
                        .otherwise().log("unkown action ${header.action}")
                            .to("log:showelse?showExchangeId=true");
            }
        });
        camelContext.start();

    }
}
