import Processor.HttpProcessor;
import org.apache.camel.Exchange;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.impl.DefaultCamelContext;
import org.apache.camel.model.ModelCamelContext;
import org.apache.log4j.PropertyConfigurator;

/**
 * Created by ztest on 2020/6/15
 */
public class ControlBus {

    public static void main(String[] args) throws Exception {
        PropertyConfigurator.configure("./conf/log4j.properties");

        ModelCamelContext camelContext = new DefaultCamelContext();
        camelContext.addRoutes(new RouteBuilder() {
            @Override
            public void configure() {
                restConfiguration().host("127.0.0.1")//127.0.0.1:8080/foo
                        .port("8286")//
                        .contextPath("xx")//
                        .setComponent("jetty");
                from("timer://myTimer?period=5000")//
                        .id("timeRoute")//
                        .setBody(simple("Current time is [ ${header.firedTime} ]"))//
                        .to("log:showelse?showExchangeId=true");
                // 以下是我们本次的研究重点
                from("rest:get:controlBus/{action}/{routeId}") // 以rest的形式约定调用格式
                        .log("begin [ ${header.action} ] the route with id [ ${header.routeId}") //
                        // 其它诸如 suspend,resume,status,stats 可依据下面格式进行选择性添加
                        .choice() //
                        .when(simple("${header.action} == 'start'")).setBody(simple("camelContext.startRoute('${header.routeId}')"))//
                        .when(simple("${header.action} == 'stop'")).setBody(simple("camelContext.stopRoute('${header.routeId}')"))//
                        .otherwise().log("unkown action ${header.action}").setBody(simple("unkown action [ ${header.action} ] FOR [ ${header.routeId} ] ")).stop() // 传入未知action, 则返回提示性信息
                        .end() //
                        .to("controlbus:language:simple");

            }
        });
        // 启动route
        camelContext.start();
        // 将我们编排的一个完整消息路由过程，加入到上下文中

    }

}
