import Processor.HttpProcessor;
import org.apache.camel.CamelContext;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.impl.DefaultCamelContext;
import org.apache.log4j.PropertyConfigurator;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by ztest on 2020/6/9
 */
public class FirstWorld {
    private static final Logger logger = LoggerFactory.getLogger(FirstWorld.class);
    public static void main(String args[]) throws Exception {
        PropertyConfigurator.configure("./conf/log4j.properties");
        logger.info("message:33");

        // create CamelContext
        CamelContext context = new DefaultCamelContext();

        // add our route to the CamelContext
        context.addRoutes(new RouteBuilder() {
            public void configure() {
                /**
                 file: 表示使用文件Component
                 from 表示从哪里获取数据，进行消费
                 to  表示将数据生产到哪里
                 */
                //.process(new HttpProcessor())
                //               .bean(String.class)
//                .transform(body().regexReplaceAll("\n", "<br/>"))
                from("direct:aa").process(new HttpProcessor())
                        .to("log:helloworld?showExchangeId=true");
            }
        });

        // start the route and let it do its work
        context.start();
        Thread.sleep(10000);



        // stop the CamelContext
        context.stop();
    }

}
