import Processor.HttpProcessor;
import Processor.SpecialProcessor;
import org.apache.camel.Exchange;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.impl.DefaultCamelContext;
import org.apache.camel.model.ModelCamelContext;

import org.apache.log4j.PropertyConfigurator;
import org.apache.log4j.Logger;


/**
 * Created by ztest on 2020/6/9
 */
public class Main extends RouteBuilder {

    public static final Logger logger = Logger.getLogger(Main.class);
    //private static final Logger logger = LoggerFactory.getLogger(Main.class);

    public static void main(String[] args) throws Exception {
        System.out.print("hello tps");

        PropertyConfigurator.configure("./conf/log4j.properties");
        logger.info("message:22");

        // 这是camel上下文对象，整个路由的驱动全靠它了。
        ModelCamelContext camelContext = new DefaultCamelContext();
        // 启动route
        camelContext.start();
        // 将我们编排的一个完整消息路由过程，加入到上下文中
        camelContext.addRoutes(new Main());
        logger.info("message:zz");

        // 为了保证主线程不退出
        synchronized (Main.class) {
            Main.class.wait();
        }
    }

    @Override
    public void configure() throws Exception {
        from("jetty:http://127.0.0.1:8282/xStartFlow")
                .process(new HttpProcessor())
                .setHeader(Exchange.HTTP_METHOD, constant("POST"))
                .setHeader(Exchange.CONTENT_TYPE, constant("application/json"))
                .to("http4://127.0.0.1:8085/xx/func/testM")
                .convertBodyTo(String.class)
                .choice()
                .when(header("route").isEqualTo("bar")).to("log:showbar?showExchangeId=true")
                .when(header("route").isEqualTo("cheese")).to("log:showcheese?showExchangeId=true")
                .otherwise().to("log:showelse?showExchangeId=true").end()
                .process(new SpecialProcessor())
                .setHeader(Exchange.HTTP_METHOD, constant("POST"))
                .setHeader(Exchange.CONTENT_TYPE, constant("application/json"))
                .to("http4://99.47.192.16:7016/xx/xx/xx/xx")
                .convertBodyTo(String.class)
                .to("log:xx?showExchangeId=true");

    }
}
