import Processor.HttpProcessor;
import org.apache.camel.Exchange;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.impl.DefaultCamelContext;
import org.apache.camel.model.ModelCamelContext;
import org.apache.log4j.PropertyConfigurator;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * test
 */
public class ParallelMulticast {
    public static void main(String[] args) throws Exception {
        PropertyConfigurator.configure("./conf/log4j.properties");

        ModelCamelContext camelContext = new DefaultCamelContext();
        final ExecutorService executor = Executors.newFixedThreadPool(16);
        camelContext.addRoutes(new RouteBuilder() {
            @Override
            public void configure() {
                from("jetty:http://127.0.0.1:8282/xStartFlow")
                        .process(new HttpProcessor())
                        .setHeader(Exchange.HTTP_METHOD, constant("POST"))
                        .setHeader(Exchange.CONTENT_TYPE, constant("application/json"))
                        .to("http4://127.0.0.1:8085/xx/func/testM")
                        .convertBodyTo(String.class)
                        .multicast().parallelProcessing().executorService(executor)
                        .to("log:showParabar?showExchangeId=true", "log:ParaCheese?showExchangeId=true");
            }});
        // 启动route
        camelContext.start();
        // 将我们编排的一个完整消息路由过程，加入到上下文中

    }
}
