import Component.MyFileComponent;
import junit.framework.TestCase;

/**
 * Created by ztest on 2020/6/12
 */
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;

import org.apache.camel.CamelContext;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.impl.DefaultCamelContext;

public class MyComponentTest {

    /**
     * @param args
     * @throws Exception
     */
    public static void main(String[] args) throws Exception {
        CamelContext camelContext = new DefaultCamelContext();
        //为了简单起见，用该方法替代了在类路径META-INF/services/org/apache/camel/component/下放置properties文件方式
        camelContext.addComponent("myfile", new MyFileComponent());

        camelContext.addRoutes(new RouteBuilder() {

            @Override
            public void configure() throws Exception {
                this.from("myfile:C:/test/in").process(new Processor() {
                    public void process(Exchange exchange) throws Exception {
                        File file = exchange.getIn().getBody(File.class);
                        PrintStream ps = new PrintStream(System.out);
                        BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
                        try {
                            String line = null;
                            while((line=br.readLine())!=null) {
                                ps.println(line);
                            }
                            ps.close();
                            br.close();
                        }
                       catch (Exception e){}
                       finally {
                            br.close();
                        }
                    }
                }).to("myfile:C:/test/out");

            }
        });

        camelContext.start();

        Object object = new Object();
        synchronized (object) {
            object.wait();
        }
    }

}
